# NOTE: this class has been translated from Java.
# Do not modify this file, changes will be overwritten.

#package orbitgt.mapping3d.sdk.viewer;

from .....com.orbitgis.lib.lang.Boolean import Boolean
from .....com.orbitgis.lib.lang.Double import Double
from .....com.orbitgis.lib.lang.Integer import Integer
from .....com.orbitgis.lib.lang.StringBuilder import StringBuilder

from .....com.orbitgis.lib.lang.RuntimeException import RuntimeException
from .....orbitgt.mapping3d.sdk.viewer.AList import AList
from .....orbitgt.mapping3d.sdk.viewer.AMap import AMap
from .....orbitgt.mapping3d.sdk.viewer.Bounds import Bounds
from .....orbitgt.mapping3d.sdk.viewer.Collections import Collections
from .....orbitgt.mapping3d.sdk.viewer.Color import Color
from .....orbitgt.mapping3d.sdk.viewer.Coordinate import Coordinate
from .....orbitgt.mapping3d.sdk.viewer.CoordinatePart import CoordinatePart
from .....orbitgt.mapping3d.sdk.viewer.CoordinatePath import CoordinatePath
from .....orbitgt.mapping3d.sdk.viewer.Error import Error
from .....orbitgt.mapping3d.sdk.viewer.IList import IList
from .....orbitgt.mapping3d.sdk.viewer.IMap import IMap
from .....orbitgt.mapping3d.sdk.viewer.MapObject import MapObject
from .....orbitgt.mapping3d.sdk.viewer.MeasureProperty import MeasureProperty
from .....orbitgt.mapping3d.sdk.viewer.MeasureState import MeasureState
from .....com.orbitgis.tool.Strings import Strings

#
# Class SerializeUtil converts objects to and from serial strings.
#


class SerializeUtil:
    # The name of the property that defines the type of the class */
    CLASS_NAME: str = "_c"

    # Curly brances defined here as top-level constants
    # due to issues with the orbit_core_api/tools utility that extracts public keywords.

    # Curly brace open character "{" */
    CURLY_BRACE_OPEN: int = 123
    # Curly brace close character "}" */
    CURLY_BRACE_CLOSE: int = 125
    # The key-value pair separator ";" */
    SEMICOLON: int = 59

    #
    # Serialize the object.
    # @return the object properties.
    #

    def serializeBounds(instance: Bounds) -> AMap[object]:
        state = AMap[object](Collections.TYPE_OBJECT)
        state.setString(SerializeUtil.CLASS_NAME,Bounds.TYPE)
        if (instance.crs!=None): state.setString("c",instance.crs)
        state.setFloat("x0",instance.minX)
        state.setFloat("y0",instance.minY)
        state.setFloat("z0",instance.minZ)
        state.setFloat("x1",instance.maxX)
        state.setFloat("y1",instance.maxY)
        state.setFloat("z1",instance.maxZ)
        state.setBoolean("3",instance.is3D)
        state.setBoolean("v",instance.valid)
        return state

    #
    # Deserialize an object.
    # @param state0 the object properties.
    # @return a new object instance.
    #

    def deserializeBounds(state0: object) -> Bounds:
        if (state0==None): return None
        state = state0
        instance = Bounds(None)
        instance.crs = state.getString2("c",None)
        instance.minX = state.getFloat2("x0",0.0)
        instance.minY = state.getFloat2("y0",0.0)
        instance.minZ = state.getFloat2("z0",0.0)
        instance.maxX = state.getFloat2("x1",0.0)
        instance.maxY = state.getFloat2("y1",0.0)
        instance.maxZ = state.getFloat2("z1",0.0)
        instance.is3D = state.getBoolean2("3",False)
        instance.valid = state.getBoolean2("v",False)
        return instance

    #
    # Serialize the object.
    # @return the object properties.
    #

    def serializeColor(instance: Color) -> AMap[object]:
        state = AMap[object](Collections.TYPE_OBJECT)
        state.setString(SerializeUtil.CLASS_NAME,Color.TYPE)
        state.setInt("r",instance.red)
        state.setInt("g",instance.green)
        state.setInt("b",instance.blue)
        if (instance.alpha!=255): state.setInt("a",instance.alpha)
        return state

    #
    # Deserialize an object.
    # @param state0 the object properties.
    # @return a new object instance.
    #

    def deserializeColor(state0: object) -> Color:
        if (state0==None): return None
        state = state0
        instance = Color(0,0,0,0)
        instance.red = state.getInt2("r",0)
        instance.green = state.getInt2("g",0)
        instance.blue = state.getInt2("b",0)
        instance.alpha = state.getInt2("a",255)
        return instance

    #
    # Serialize the object.
    # @return the object properties.
    #

    def serializeCoordinate(instance: Coordinate) -> AMap[object]:
        state = AMap[object](Collections.TYPE_OBJECT)
        state.setString(SerializeUtil.CLASS_NAME,Coordinate.TYPE)
        if (instance.crs!=None): state.setString("c",instance.crs)
        if (instance.x!=0.0): state.setFloat("x",instance.x)
        if (instance.y!=0.0): state.setFloat("y",instance.y)
        if (instance.is3D):
            if (instance.z!=0.0): state.setFloat("z",instance.z)
            state.setBoolean("3",True)
        return state

    #
    # Deserialize an object.
    # @param state0 the object properties.
    # @return a new object instance.
    #

    def deserializeCoordinate(state0: object) -> Coordinate:
        if (state0==None): return None
        state = state0
        instance = Coordinate(None,0.0,0.0,0.0,False)
        instance.crs = state.getString2("c",None)
        instance.x = state.getFloat2("x",0.0)
        instance.y = state.getFloat2("y",0.0)
        instance.is3D = state.getBoolean2("3",False)
        if (instance.is3D):
            instance.z = state.getFloat2("z",0.0)
        return instance

    #
    # Serialize the object.
    # @return the object properties.
    #

    def serializeCoordinatePart(instance: CoordinatePart) -> AMap[object]:
        state = AMap[object](Collections.TYPE_OBJECT)
        state.setString(SerializeUtil.CLASS_NAME,CoordinatePart.TYPE)
        state.setInt("c",instance.points.size())
        for i in range(0,instance.points.size()): state.setObject(Strings.toString(i),SerializeUtil.serializeCoordinate(instance.points.get(i)))
        return state

    #
    # Deserialize an object.
    # @param state0 the object properties.
    # @return a new object instance.
    #

    def deserializeCoordinatePart(state0: object) -> CoordinatePart:
        if (state0==None): return None
        state = state0
        instance = CoordinatePart()
        pointCount = state.getInt2("c",0)
        for i in range(0,pointCount): instance.points.add(SerializeUtil.deserializeCoordinate(state.getObject2(Strings.toString(i),None)))
        return instance

    #
    # Serialize the object.
    # @return the object properties.
    #

    def serializeCoordinatePath(instance: CoordinatePath) -> AMap[object]:
        state = AMap[object](Collections.TYPE_OBJECT)
        state.setString(SerializeUtil.CLASS_NAME,CoordinatePath.TYPE)
        state.setInt("c",instance.parts.size())
        for i in range(0,instance.parts.size()): state.setObject(Strings.toString(i),SerializeUtil.serializeCoordinatePart(instance.parts.get(i)))
        return state

    #
    # Deserialize an object.
    # @param state0 the object properties.
    # @return a new object instance.
    #

    def deserializeCoordinatePath(state0: object) -> CoordinatePath:
        if (state0==None): return None
        state = state0
        instance = CoordinatePath()
        partCount = state.getInt2("c",0)
        for i in range(0,partCount): instance.parts.add(SerializeUtil.deserializeCoordinatePart(state.getObject2(Strings.toString(i),None)))
        return instance

    #
    # Serialize the object.
    # @return the object properties.
    #

    def serializeError(instance: Error) -> AMap[object]:
        state = AMap[object](Collections.TYPE_OBJECT)
        state.setString(SerializeUtil.CLASS_NAME,Error.TYPE)
        if (instance.code!=None): state.setString("c",instance.code)
        if (instance.errorMessage!=None): state.setString("m",instance.errorMessage)
        return state

    #
    # Deserialize an object.
    # @param state0 the object properties.
    # @return a new object instance.
    #

    def deserializeError(state0: object) -> Error:
        if (state0==None): return None
        state = state0
        instance = Error(None,None)
        instance.code = state.getString2("c",None)
        instance.errorMessage = state.getString2("m",None)
        return instance

    #
    # Serialize the object.
    # @return the object properties.
    #

    def serializeList(list: IList) -> AMap[object]:
        state = AMap[object](Collections.TYPE_OBJECT)
        state.set(SerializeUtil.CLASS_NAME,Collections.TYPE_LIST)
        state.setString("_t",list.getGenericType())
        state.setInt("_s",list.size())
        for i in range(0,list.size()): state.set(Strings.toString(i),SerializeUtil.serializeObject(list.getObject(i)))
        return state

    #
    # Deserialize an object.
    # @param state0 the object properties.
    # @return a new object instance.
    #

    def deserializeList(state0: object) -> IList:
        if (state0==None): return None
        state = state0
        genericType = state.getString2("_t",None)
        instance = Collections.createList(genericType)
        elementCount = state.getInt2("_s",0)
        for i in range(0,elementCount): instance.addObject(SerializeUtil.deserializeObject(state.getObject2(Strings.toString(i),None)))
        return instance

    #
    # Serialize the object.
    # @return the object properties.
    #

    def serializeMap(map: IMap) -> AMap[object]:
        state = AMap[object](Collections.TYPE_OBJECT)
        state.set(SerializeUtil.CLASS_NAME,Collections.TYPE_MAP)
        state.set("_t",map.getGenericType())
        keys = map.listKeys()
        for i in range(0,keys.size()): state.set(keys.get(i),SerializeUtil.serializeObject(map.getObject2(keys.get(i),None)))
        return state

    #
    # Deserialize an object.
    # @param state0 the object properties.
    # @return a new object instance.
    #

    def deserializeMap(state0: object) -> IMap:
        if (state0==None): return None
        state = state0
        genericType = state.getString2("_t",None)
        instance = Collections.createMap(genericType)
        keys = state.listKeys()
        for i in range(0,keys.size()): instance.setObject(keys.get(i),SerializeUtil.deserializeObject(state.getObject2(keys.get(i),None)))
        return instance

    #
    # Serialize the object.
    # @return the object properties.
    #

    def serializeMapObject(instance: MapObject) -> AMap[object]:
        state = AMap[object](Collections.TYPE_OBJECT)
        state.setString(SerializeUtil.CLASS_NAME,MapObject.TYPE)
        if (instance.spatialPoint!=None): state.setObject("sp",SerializeUtil.serializeCoordinate(instance.spatialPoint))
        if (instance.spatialLine!=None): state.setObject("sl",SerializeUtil.serializeCoordinatePath(instance.spatialLine))
        if (instance.spatialArea!=None): state.setObject("sa",SerializeUtil.serializeCoordinatePath(instance.spatialArea))
        if (instance.resourceId!=None): state.setString("ri",instance.resourceId)
        if (instance.objectType!=None): state.setString("ot",instance.objectType)
        if (instance.objectId!=None): state.setString("oi",instance.objectId)
        if (instance.label!=None): state.setString("l",instance.label)
        if (instance.labelPosition!=None): state.setObject("lp",SerializeUtil.serializeCoordinate(instance.labelPosition))
        if (instance.labelFontSize!=0.0): state.setFloat("lfs",instance.labelFontSize)
        if (instance.labelFontName!=None): state.setString("lfn",instance.labelFontName)
        if (instance.labelColor!=None): state.setObject("lc",SerializeUtil.serializeColor(instance.labelColor))
        if (instance.color!=None): state.setObject("c",SerializeUtil.serializeColor(instance.color))
        if (instance.fillColor!=None): state.setObject("fc",SerializeUtil.serializeColor(instance.fillColor))
        if (instance.lineWidth!=0.0): state.setFloat("lw",instance.lineWidth)
        if (instance.symbolName!=None): state.setString("yn",instance.symbolName)
        if (instance.symbolPath!=None): state.setObject("yp",SerializeUtil.serializeCoordinatePath(instance.symbolPath))
        if (instance.symbolSize!=0.0): state.setFloat("ys",instance.symbolSize)
        return state

    #
    # Deserialize an object.
    # @param state0 the object properties.
    # @return a new object instance.
    #

    def deserializeMapObject(state0: object) -> MapObject:
        if (state0==None): return None
        state = state0
        instance = MapObject()
        instance.spatialPoint = SerializeUtil.deserializeCoordinate(state.getObject2("sp",None))
        instance.spatialLine = SerializeUtil.deserializeCoordinatePath(state.getObject2("sl",None))
        instance.spatialArea = SerializeUtil.deserializeCoordinatePath(state.getObject2("sa",None))
        instance.resourceId = state.getString2("ri",None)
        instance.objectType = state.getString2("ot",None)
        instance.objectId = state.getString2("oi",None)
        instance.label = state.getString2("l",None)
        instance.labelPosition = SerializeUtil.deserializeCoordinate(state.getObject2("lp",None))
        instance.labelFontSize = state.getFloat2("lfs",0.0)
        instance.labelFontName = state.getString2("lfn",None)
        instance.labelColor = SerializeUtil.deserializeColor(state.getObject2("lc",None))
        instance.color = SerializeUtil.deserializeColor(state.getObject2("c",None))
        instance.fillColor = SerializeUtil.deserializeColor(state.getObject2("fc",None))
        instance.lineWidth = state.getFloat2("lw",0.0)
        instance.symbolName = state.getString2("yn",None)
        instance.symbolPath = SerializeUtil.deserializeCoordinatePath(state.getObject2("yp",None))
        instance.symbolSize = state.getFloat2("ys",0.0)
        return instance

    #
    # Serialize the object.
    # @return the object properties.
    #

    def serializeMeasureProperty(instance: MeasureProperty) -> AMap[object]:
        state = AMap[object](Collections.TYPE_OBJECT)
        state.setString(SerializeUtil.CLASS_NAME,MeasureProperty.TYPE)
        if (instance.name!=None): state.setString("n",instance.name)
        if (instance.label!=None): state.setString("l",instance.label)
        if (instance.value!=None): state.setString("v",instance.value)
        if (instance.unit!=None): state.setString("u",instance.unit)
        return state

    #
    # Deserialize an object.
    # @param state0 the object properties.
    # @return a new object instance.
    #

    def deserializeMeasureProperty(state0: object) -> MeasureProperty:
        if (state0==None): return None
        state = state0
        instance = MeasureProperty(None,None,None,None)
        instance.name = state.getString2("n",None)
        instance.label = state.getString2("l",None)
        instance.value = state.getString2("v",None)
        instance.unit = state.getString2("u",None)
        return instance

    #
    # Serialize the object.
    # @return the object properties.
    #

    def serializeMeasureState(instance: MeasureState) -> AMap[object]:
        state = AMap[object](Collections.TYPE_OBJECT)
        state.setString(SerializeUtil.CLASS_NAME,MeasureState.TYPE)
        if (instance.isComplete): state.setBoolean("i",True)
        if (instance.spatialPoint!=None): state.setObject("c",SerializeUtil.serializeCoordinate(instance.spatialPoint))
        if (instance.spatialLine!=None): state.setObject("l",SerializeUtil.serializeCoordinatePath(instance.spatialLine))
        if (instance.spatialArea!=None): state.setObject("a",SerializeUtil.serializeCoordinatePath(instance.spatialArea))
        if (instance.mode!=None): state.setString("m",instance.mode)
        if (instance.properties!=None): state.setObject("r",SerializeUtil.serializeList(instance.properties))
        if (instance.mapObjects!=None): state.setObject("o",SerializeUtil.serializeList(instance.mapObjects))
        return state

    #
    # Deserialize an object.
    # @param state0 the object properties.
    # @return a new object instance.
    #

    def deserializeMeasureState(state0: object) -> MeasureState:
        if (state0==None): return None
        state = state0
        instance = MeasureState()
        instance.isComplete = state.getBoolean2("i",False)
        instance.spatialPoint = SerializeUtil.deserializeCoordinate(state.getObject2("c",None))
        instance.spatialLine = SerializeUtil.deserializeCoordinatePath(state.getObject2("l",None))
        instance.spatialArea = SerializeUtil.deserializeCoordinatePath(state.getObject2("a",None))
        instance.mode = state.getString2("m",None)
        instance.properties = SerializeUtil.deserializeList(state.getObject2("r",None))
        instance.mapObjects = SerializeUtil.deserializeList(state.getObject2("o",None))
        return instance

    #
    # Deserialize an object.
    # @param value the serialized value of the object.
    # @return the object.
    #

    def deserializeObject(value: object) -> object:
        if (value==None): return None
        #if (Std.is(value,Bool)) return value; // haxe add line
        #if (Std.is(value,Int)) return value; // haxe add line
        #if (Std.is(value,Float)) return value; // haxe add line
        #if (typeof(value)==="boolean") return value; // typescript add line
        #if (typeof(value)==="number") return value; // typescript add line
        #if (typeof(value)==="string") return value; // typescript add line
        if (isinstance(value,Boolean)): return value
        if (isinstance(value,Integer)): return value
        if (isinstance(value,Double)): return value
        if (isinstance(value,str)): return value
        state = value
        className = state.getString2(SerializeUtil.CLASS_NAME,None)
        if (className==None): return None
        if (Strings.equals(className,Collections.TYPE_LIST)): return SerializeUtil.deserializeList(state)
        if (Strings.equals(className,Collections.TYPE_MAP)): return SerializeUtil.deserializeMap(state)
        if (Strings.equals(className,Bounds.TYPE)): return SerializeUtil.deserializeBounds(state)
        if (Strings.equals(className,Color.TYPE)): return SerializeUtil.deserializeColor(state)
        if (Strings.equals(className,Coordinate.TYPE)): return SerializeUtil.deserializeCoordinate(state)
        if (Strings.equals(className,CoordinatePart.TYPE)): return SerializeUtil.deserializeCoordinatePart(state)
        if (Strings.equals(className,CoordinatePath.TYPE)): return SerializeUtil.deserializeCoordinatePath(state)
        if (Strings.equals(className,Error.TYPE)): return SerializeUtil.deserializeError(state)
        if (Strings.equals(className,MapObject.TYPE)): return SerializeUtil.deserializeMapObject(state)
        if (Strings.equals(className,MeasureProperty.TYPE)): return SerializeUtil.deserializeMeasureProperty(state)
        if (Strings.equals(className,MeasureState.TYPE)): return SerializeUtil.deserializeMeasureState(state)
        raise RuntimeException("Cannot deserialize object class: '"+className+"'")

    #
    # Serialize an object.
    # @param object the object to serialize.
    # @return the serialized object.
    #

    def serializeObject(instance: object) -> object:
        if (instance==None): return None
        #if (Std.is(instance,Bool)) return instance; // haxe add line
        #if (Std.is(instance,Int)) return instance; // haxe add line
        #if (Std.is(instance,Float)) return instance; // haxe add line
        #if (typeof(instance)==="boolean") return instance; // typescript add line
        #if (typeof(instance)==="number") return instance; // typescript add line
        #if (typeof(instance)==="string") return instance; // typescript add line
        if (isinstance(instance,Boolean)): return instance
        if (isinstance(instance,Integer)): return instance
        if (isinstance(instance,Double)): return instance
        if (isinstance(instance,str)): return instance
        if (isinstance(instance,AList)): return SerializeUtil.serializeList(instance); # csharp remove line
        if (isinstance(instance,IList)): return SerializeUtil.serializeList(instance); # typescript remove line
        if (isinstance(instance,AMap)): return SerializeUtil.serializeMap(instance); # csharp remove line
        if (isinstance(instance,IMap)): return SerializeUtil.serializeMap(instance); # typescript remove line
        if (isinstance(instance,Bounds)): return SerializeUtil.serializeBounds(instance)
        if (isinstance(instance,Color)): return SerializeUtil.serializeColor(instance)
        if (isinstance(instance,Coordinate)): return SerializeUtil.serializeCoordinate(instance)
        if (isinstance(instance,CoordinatePart)): return SerializeUtil.serializeCoordinatePart(instance)
        if (isinstance(instance,CoordinatePath)): return SerializeUtil.serializeCoordinatePath(instance)
        if (isinstance(instance,Error)): return SerializeUtil.serializeError(instance)
        if (isinstance(instance,MapObject)): return SerializeUtil.serializeMapObject(instance)
        if (isinstance(instance,MeasureProperty)): return SerializeUtil.serializeMeasureProperty(instance)
        if (isinstance(instance,MeasureState)): return SerializeUtil.serializeMeasureState(instance)
        raise RuntimeException("Cannot serialize object: "+instance)

    #
    # Check if a string character code need special encoding.
    # @param c the numeric code.
    # @return true if special coding is needed.
    #

    def isSpecialChar(c: int) -> bool:
        if (c<32): return True
        if (c>127): return True
        # ~
        if (c==126): return True
        # {
        if (c==123): return True
        # }
        if (c==125): return True
        # ;
        if (c==59): return True
        return False

    #
    # Encode a string value.
    # @param text the value.
    # @return the encoded value.
    #

    def encodeString(text: str) -> str:
        # Check for special characters */
        valid = True
        for i in range(0,Strings.getLength(text)):
            c = Strings.charCodeAt(text,i)
            if (SerializeUtil.isSpecialChar(c)): valid = False
        if (valid): return text
        # Encode */
        text2 = StringBuilder()
        for i in range(0,Strings.getLength(text)):
            c = Strings.charCodeAt(text,i)
            if (SerializeUtil.isSpecialChar(c)):
                text2.append("~"+c+"~")
            else:
                text2.append(Strings.charCodeToString(c))
        return text2.toString()

    #
    # Decode a string value.
    # @param text the encoded value.
    # @return the value.
    #

    def decodeString(text: str) -> str:
        # Check for special characters */
        valid = True
        for i in range(0,Strings.getLength(text)):
            c = Strings.charCodeAt(text,i)
            if (c==126): valid = False
        if (valid): return text
        # Decode */
        text2 = StringBuilder()
        j = 0
        while (j<Strings.getLength(text)):
            c = Strings.charCodeAt(text,j)
            if (c==126):
                j2 = Strings.indexOfFrom(text,"~",j+1)
                v = Integer.parseInt(Strings.substring(text,j+1,j2))
                text2.append(Strings.charCodeToString(v))
                j = j2
            else:
                text2.append(Strings.charCodeToString(c))
            j += 1
        return text2.toString()

    #
    # Encode a properties map into a text.
    # @param map the properties map.
    # @param text the text buffer to add to.
    #

    def mapToString(map: IMap,text: StringBuilder) -> None:
        text.append(Strings.charCodeToString(SerializeUtil.CURLY_BRACE_OPEN))
        keys = map.listKeys()
        for i in range(0,keys.size()):
            if (i>0): text.append(";")
            key = keys.get(i)
            if (Strings.indexOf(key,":")>=0): raise RuntimeException("Property key name '"+key+"' cannot include the ':' character")
            value = map.getObject2(key,None)
            text.append(key)
            text.append(":")
            isMap = False
            if (isinstance(value,AMap)): isMap = True; # csharp remove line
            if (isinstance(value,IMap)): isMap = True; # typescript remove line
            if (value==None): text.append("n")
            #else if (Std.is(value,Bool)) text.add(cast(value,Bool)?"bT":"bF"); // haxe add line
            #else if (Std.is(value,Int)) text.add("i"+value); // haxe add line
            #else if (Std.is(value,Float)) text.add("f"+value); // haxe add line
            #else if (typeof(value)==="boolean") text.append(value?"bT":"bF"); // typescript add line
            #else if (typeof(value)==="number" && Number.isInteger(value)) text.append("i"+value); // typescript add line
            #else if (typeof(value)==="number" && Number.isInteger(value)===false) text.append("f"+value); // typescript add line
            elif (isinstance(value,Boolean)):
                tvalue = value
                if (tvalue.booleanValue()): text.append("bT")
                else: text.append("bF")
            elif (isinstance(value,Integer)): text.append("i"+Strings.toString(value))
            elif (isinstance(value,Double)): text.append("f"+Strings.toString(value))
            elif (isinstance(value,str)): text.append("s"+SerializeUtil.encodeString(Strings.toString(value)))
            elif (isMap):
                tvalue = (value)
                SerializeUtil.mapToString(tvalue,text)
            else: raise RuntimeException("Cannot encode to string: value ["+Strings.toString(value)+"] of key '"+key+"'")
        text.append(Strings.charCodeToString(SerializeUtil.CURLY_BRACE_CLOSE))

    #
    # Decode a text to a properties map.
    # @param text the text.
    # @param textPos the position to decode at.
    # @return the properties map.
    #

    def stringToMap(text: str,textPos: int) -> AMap[object]:
        instance = AMap[object](Collections.TYPE_OBJECT)
        if (Strings.charCodeAt(text,textPos)!=SerializeUtil.CURLY_BRACE_OPEN): raise RuntimeException("Expected '{' at position "+textPos+" of text '"+text+"'")
        textPos += 1
        while (Strings.charCodeAt(text,textPos)!=SerializeUtil.CURLY_BRACE_CLOSE):
            # Find the property name */
            keyIndex = textPos
            textPos = Strings.indexOfFrom(text,":",keyIndex)
            key = Strings.substring(text,keyIndex,textPos)
            textPos += 1
            # Find the property value */
            valueIndex = textPos
            level = 0
            while (True):
                c = Strings.charCodeAt(text,textPos)
                if ((c==SerializeUtil.SEMICOLON) and (level==0)): break
                if ((c==SerializeUtil.CURLY_BRACE_CLOSE) and (level==0)): break
                if (c==SerializeUtil.CURLY_BRACE_OPEN): level += 1
                if (c==SerializeUtil.CURLY_BRACE_CLOSE): level -= 1
                textPos += 1
            value = Strings.substring(text,valueIndex,textPos)
            if (Strings.charCodeAt(text,textPos)==SerializeUtil.SEMICOLON): textPos += 1
            # Decode the property */
            #trace("READ KEY '"+key+"' WITH VALUE '"+value+"'");
            if (Strings.equals(value,"n")): instance.setObject(key,None)
            #else if (Strings.startsWith(value,"b")) instance.setObject(key,(value=="bT")); // haxe add line
            #else if (Strings.startsWith(value,"i")) instance.setObject(key,Std.parseInt(value.substring(1))); // haxe add line
            #else if (Strings.startsWith(value,"f")) instance.setObject(key,Std.parseFloat(value.substring(1))); // haxe add line
            #else if (Strings.startsWith(value,"b")) instance.setObject(key,(value=="bT")); // typescript add line
            #else if (Strings.startsWith(value,"i")) instance.setObject(key,parseInt(value.substring(1))); // typescript add line
            #else if (Strings.startsWith(value,"f")) instance.setObject(key,parseFloat(value.substring(1))); // typescript add line
            elif (Strings.startsWith(value,"b")):
                bvalue = Strings.equals(value,"bT")
                if (bvalue): instance.setObject(key,"true")
                else: instance.setObject(key,"false")
            elif (Strings.startsWith(value,"i")): instance.setObject(key,Integer.parseInt(Strings.substringFrom(value,1)))
            elif (Strings.startsWith(value,"f")): instance.setObject(key,Double.parseDouble(Strings.substringFrom(value,1)))
            elif (Strings.startsWith(value,"s")): instance.setObject(key,SerializeUtil.decodeString(Strings.substringFrom(value,1)))
            else: instance.setObject(key,SerializeUtil.stringToMap(text,valueIndex))
        if (Strings.charCodeAt(text,textPos)!=SerializeUtil.CURLY_BRACE_CLOSE): raise RuntimeException("Expected '}' at position "+textPos+" of text '"+text+"'")
        textPos += 1
        return instance

    #
    # Convert an object to an encoded string.
    # @param instance the object.
    # @return the encoded string.
    #

    def serialize(instance: object) -> str:
        if (instance==None): return "n"
        #if (Std.is(instance,Bool)) return cast(instance,Bool)?"bT":"bF"; // haxe add line
        #if (Std.is(instance,Int)) return "i"+instance; // haxe add line
        #if (Std.is(instance,Float)) return "f"+instance; // haxe add line
        #if (typeof(instance)==="boolean") return instance?"bT":"bF"; // typescript add line
        #if (typeof(instance)==="number" && Number.isInteger(instance)) return "i"+instance; // typescript add line
        #if (typeof(instance)==="number" && Number.isInteger(instance)===false) return "f"+instance; // typescript add line
        if (isinstance(instance,Boolean)):
            tvalue = instance
            if (tvalue.booleanValue()): return "bT"
            else: return "bF"
        if (isinstance(instance,Integer)): return "i"+Strings.toString(instance)
        if (isinstance(instance,Double)): return "f"+Strings.toString(instance)
        if (isinstance(instance,str)): return "s"+SerializeUtil.encodeString(Strings.toString(instance))
        properties = SerializeUtil.serializeObject(instance)
        text = StringBuilder()
        SerializeUtil.mapToString(properties,text)
        #trace("Serialized object to text of size "+text.length+": "+text);
        return text.toString()

    #
    # Convert an encoded string into an object.
    # @param data the encoded string.
    # @return the object.
    #
    def deserialize(text: str) -> object:
        if (text==None): raise RuntimeException("Cannot deserialize a null text")
        if (Strings.getLength(text)==0): return None
        #trace("Deserializing object text of size "+text.length+": "+text);
        if (Strings.equals(text,"n")): return None
        #if (Strings.startsWith(text,"b")) return (text=="bT"); // haxe add line
        #if (Strings.startsWith(text,"i")) return Std.parseInt(text.substring(1)); // haxe add line
        #if (Strings.startsWith(text,"f")) return Std.parseFloat(text.substring(1)); // haxe add line
        #if (Strings.startsWith(text,"b")) return (text=="bT"); // typescript add line
        #if (Strings.startsWith(text,"i")) return parseInt(text.substring(1)); // typescript add line
        #if (Strings.startsWith(text,"f")) return parseFloat(text.substring(1)); // typescript add line
        if (Strings.startsWith(text,"b")):
            if (Strings.equals(text,"bT")): return Boolean.TRUE
            else: return Boolean.FALSE
        if (Strings.startsWith(text,"i")): return Integer(Integer.parseInt(Strings.substringFrom(text,1)))
        if (Strings.startsWith(text,"f")): return Double(Double.parseDouble(Strings.substringFrom(text,1)))
        if (Strings.startsWith(text,"s")): return SerializeUtil.decodeString(Strings.substringFrom(text,1))
        properties = SerializeUtil.stringToMap(text,0)
        return SerializeUtil.deserializeObject(properties)
