from typing import Callable,Generic,List,TypeVar

T = TypeVar('T')

class Signal(Generic[T]):
    def __init__(self):
        self.myCallbacks = []

    def add(self,listener: Callable[[T],None]) -> None:
        self.myCallbacks.append(listener)

    def remove(self,listener: Callable[[T],None]) -> None:
        self.myCallbacks.remove(listener)

    def dispatchValue(self,value: T) -> None:
        for signalCallback in self.myCallbacks: signalCallback(value)

    def dispatchObject(self,value: object) -> None:
        for signalCallback in self.myCallbacks: signalCallback(value)
