# NOTE: this class has been translated from Java.
# Do not modify this file, changes will be overwritten.

#package orbitgt.mapping3d.sdk.viewer;

from .....com.orbitgis.lib.lang.RuntimeException import RuntimeException

#
# Class ViewerActions aims to document some viewer actions that can be triggered using the `Viewer3DM.doAction()` function.
# All actions described here can be triggered by passing a single string argument.
#
# ### Start a measurement
#
# To start measurement, you must first know the code of the measurement mode you want to start.
#
# Use these steps to determine the code of a measurement mode : <br/>
# 1. Attach a listener to the `Viewer3DM.onMeasureStateChanged` signal.<br/>
# 2. Start a measurement in the viewer (interactively).<br/>
# 3. Look at the `mode` property of the `MeasureState` instance provided as payload to the `Viewer3DM.onMeasureStateChanged` signal handler.
#
# Pass this string as first argument : `startMeasure:<mode>` where `<code>` is the measurement mode.
#
# ### Clear a measurement
#
# Pass this string : `clearMeasure`.
#
# ### Stop current measurement
#
# Pass this string : `stopMeasure`.
#
# ### Set the measurement technique
#
# Pass this string : `setSetting:measureTechnique:<technique>`.<br/>
# The constants defined on this class starting with the prefix `MEASURE_TECHNIQUE_`, can be used as values for `<technique>`.
#

class ViewerActions:

    # Identifies the "Closest point" measure technique. */
    MEASURE_TECHNIQUE_POINT_CLOUD_CLOSEST_POINT: str = "0"
    # Identifies the "Flat Surface Intersection" measure technique. */
    MEASURE_TECHNIQUE_POINT_CLOUD_FLAT_SURFACE_INTERSECTION: str = "1"
    # Identifies the "Ridges & Corners Intersection" measure technique. */
    MEASURE_TECHNIQUE_POINT_CLOUD_RIDGES_AND_CORNERS_INTERSECTION: str = "2"
    # Identifies the "DEM Intersection" measure technique. */
    MEASURE_TECHNIQUE_DEM_INTERSECTION: str = "3"
    # Identifies the "Forward Intersection" measure technique. */
    MEASURE_TECHNIQUE_FORWARD_INTERSECTION: str = "4"
    # Identifies the "Reference Planes Intersection" measure technique. */
    MEASURE_TECHNIQUE_REFERENCE_PLANES_INTERSECTION: str = "5"
    # Identifies the "Ground Surface Initersection" measure technique. */
    MEASURE_TECHNIQUE_GROUND_SURFACE_INTERSECTION: str = "6"
    # Identifies the "Mesh Intersection" measure technique. */
    MEASURE_TECHNIQUE_MESH_INTERSECTION: str = "7"
    # Identifies the "Floating Mark" measure technique. */
    MEASURE_TECHNIQUE_FLOATING_MARK: str = "8"
    # Identifies the "3D Measurement" measure technique. */
    MEASURE_TECHNIQUE_3D_MEASUREMENT: str = "9"
